This repository has been archived by the owner. It is now read-only.
A Scala wrapper for Deeplearning4j, inspired by Keras. Scala + DL + Spark + GPUs
Clone or download
Latest commit c5de988 May 21, 2018

README.md

IMPORTANT: THIS REPOSITORY HAS BEEN ARCHIVED AND SCALNET HAS BEEN MOVED

ScalNet has been migrated to a sub-module of the mono-repository here: https://github.com/deeplearning4j/deeplearning4j

All future development will continue at that repository, which should be used for all issues and pull requests.

ScalNet

ScalNet is a wrapper around Deeplearning4J emulating a Keras like API for deep learning.

ScalNet is released under an Apache 2.0 license. By contributing code to this repository, you agree to make your contribution available under an Apache 2.0 license.

ScalNet is STILL ALPHA and we are open sourcing this in an attempt to get feedback.

Come in to gitter if you are interested in learning more.

Prerequisites

  • JDK 8
  • Scala 2.11.+ or 2.10.x
  • SBT and Maven

How to build

Currently ScalNet depends on deeplearning4j and nd4j SNAPSHOTS.

sbt

ScalNet uses sbt, but due to resolving issues, you must have Maven available to copy some nd4j-native dependencies in your classpath, in order to run the examples.

This is automatically done in build.sbt and you don't need to do anything besides having maven installed.

If you use sbt in your own project, you will probably have to proceed the same way. When ScalNet will be using releases instead of snapshots, this won't be necessary anymore.

To build, use:

$ sbt package

Alternatively, for some quick testing or usage in Jupyter for example, run:

$ sbt assembly

To obtain a JAR file with all needed dependencies.

See the official sbt documentation for more on how to use sbt.

Maven

Althought Maven is mainly used for release management, you can use the provided pom.xml to import ScalNet as a Maven project.

Target for scala 2.11

$ change-scala-versions.sh "2.11"
$ mvn package

Target for scala 2.10

$ change-scala-versions.sh "2.10"
$ mvn package

How to use

sbt

libraryDependencies ++= "org.deeplearning4j" % "scalnet_2.11" % "0.9.2-SNAPSHOT"

Maven

<dependency>
    <groupId>org.deeplearning4j</groupId>
    <artifactId>scalnet_2.11</artifactId>
    <version>0.9.2-SNAPSHOT</version>
</dependency>

Getting started

ScalNet uses a Keras like API, wrapping deeplearning4j to make it more easier to start with.

Also, since you can call Java code from Scala, you can still use everything from deeplearning4j.

To see what ScalNet has to offer, run one of the examples it ships with.

Please note that those examples are not state-of-the-art in any way, they're just enough to get you started.